SystemOrganization addCategory: #'EyeSee-Events'!

Announcer subclass: #ESAnnouncer
	instanceVariableNames: 'diagramRenderer menuMorphBlock menuItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

!ESAnnouncer methodsFor: 'announce' stamp: 'AndreHora 4/18/2011 16:38'!
announce: anEvent
	
	anEvent diagramRenderer: self diagramRenderer.
	super announce: anEvent.! !

!ESAnnouncer methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 18:48'!
diagram

	^ self diagramRenderer diagram! !

!ESAnnouncer methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 16:38'!
diagramRenderer

	^ diagramRenderer! !

!ESAnnouncer methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 16:38'!
diagramRenderer: anObject

	diagramRenderer := anObject! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/13/2011 11:19'!
highlightWhenOver! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/18/2011 21:18'!
highlightWhenSelect
	
	self 
		registerForEvent: ESElementSelection 
		updateDiagram: [ :object :diagram | 
			
			diagram elements do: [ :each |
				each borderColor: (object attributeAt: #oldColor ifAbsentPut: [ object borderColor ]) ].
			
			object borderColor: object selectionColor.
		]! !

!ESAnnouncer methodsFor: 'accessing' stamp: 'AndreHora 6/13/2011 18:14'!
menuItems

	^ menuItems ifNil: [menuItems := OrderedCollection new]! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 6/13/2011 18:06'!
menuMorphBlock: aBlock 
	menuMorphBlock := aBlock.
	self registerMenu! !

!ESAnnouncer methodsFor: 'interaction support' stamp: 'AndreHora 6/13/2011 18:15'!
menuMorphFor: anElement
 
	| menuMorph |
	
	menuMorph := 
		menuMorphBlock isNil 
			ifTrue:  [ MenuMorph new ]
			ifFalse: [ menuMorphBlock moValue: anElement model ].
		
	self menuItems do: 
		[ :each | 
			menuMorph 
				add: each key
				target: each value
				selector: #value:
				argument: anElement model ].
	^ menuMorph! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/12/2011 17:45'!
noPopup! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 12/9/2011 21:31'!
popupText

	self popupText: #yourself! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/18/2011 13:57'!
popupText: aBlock

	^ self popupText: aBlock delay: 500! !

!ESAnnouncer methodsFor: 'interaction support' stamp: 'AndreHora 12/9/2011 21:31'!
popupText: aBlock delay: ms
	"open a popup text when the mouse enter a node"

	self
		subscribe: ESMouseEnter
		do: [ :ann | 
			ann hasElement
				ifTrue: [ 
					[ 
						| oldPosition relativePosition |
					  	ActiveHand
						ifNotNil: [ :arg | 
							oldPosition := ActiveHand position.
							(Delay forMilliseconds: ms) wait.	"we compute the relative position since ActiveHand return an absolute location"
							relativePosition := ann position - oldPosition + ActiveHand position.	"We check if we are in the same node, if yes, then we evaluate the view"
							((ann diagram atPoint: relativePosition) == ann current)
								ifTrue: [ESPopup show: ( [aBlock value: ann element model ] on: Error do: [ 'Error when printing' ]) asString ] ]
					] fork ]
				ifFalse: [ ESPopup remove ] ].
	self
		subscribe: ESMouseLeave
		do: [ :ann | ESPopup remove ]! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/12/2011 17:42'!
popupView: aBlock! !

!ESAnnouncer methodsFor: 'interaction support' stamp: 'AndreHora 6/13/2011 18:12'!
registerForEvent: eventClass updateDiagram: updateBlock
	
	self 
		on: eventClass do: [ :ann | 
			updateBlock value: ann element value: self diagram.
			ann diagramRenderer updateWindow.
		]! !

!ESAnnouncer methodsFor: 'interaction support' stamp: 'AndreHora 6/13/2011 18:13'!
registerMenu
	"self unsubscribeForEvent: ESMouseDown."
	self subscribe: ESMouseDown do: [ :ann |
		ann isLeftButtonPressed ifFalse: [
			(self menuMorphFor: ann element) popUpInWorld
		].
		"Clicking on a menu should make popup disappear"
		"ann element removePopupIfExist"
	].
! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/18/2011 22:15'!
strongHighlightWhenClick
	
	self 
		registerForEvent: ESMouseDown
		updateDiagram: [ :object :diagram | 
			| temp |
			temp := object color.
			object color: (object attributeAt: #nextColor ifAbsentPut: [ Color green ]).
			object attributeAt: #nextColor put: temp.
		]! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/18/2011 22:16'!
strongHighlightWhenOver
	
	self 
		registerForEvent: ESMouseEnter
		updateDiagram: [ :object :diag | 
			object color: (object attributeAt: #oldColor ifAbsentPut: [ object color ]).
			object color: Color green.
		].
	
	self 
		registerForEvent: ESMouseLeave
		updateDiagram: [ :object :diag | 
			object color: (object attributeAt: #oldColor).
		]! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/18/2011 19:09'!
strongHighlightWhenSelect
	
	self 
		registerForEvent: ESElementSelection 
		updateDiagram: [ :object :diagram | 
			
			diagram elements do: [ :each |
				each color: (object attributeAt: #oldColor ifAbsentPut: [ object color ]) ].
			
			object color: Color green.
		]! !

!ESAnnouncer methodsFor: 'interaction' stamp: 'AndreHora 4/12/2011 17:43'!
windowStatus: aBlock! !

Announcement subclass: #ESEvent
	instanceVariableNames: 'event element current diagramRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESEvent subclass: #ESElementDeselection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESEvent subclass: #ESElementSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

!ESEvent classSide methodsFor: 'instance creation' stamp: 'AndreHora 4/13/2011 10:22'!
event: aMorphicEvent on: anElement
	^ self new initializeEvent: aMorphicEvent on: anElement! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
current
	^ current! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
current: anObject
	^ current := anObject! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 16:37'!
diagram

	^ self diagramRenderer diagram! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 16:37'!
diagramRenderer

	^ diagramRenderer! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 16:38'!
diagramRenderer: anObject

	diagramRenderer := anObject! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
element
	^ element! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
element: anObject
	element := anObject! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
event
	^ event! !

!ESEvent methodsFor: 'accessing' stamp: 'AndreHora 4/13/2011 10:22'!
event: anObject
	event := anObject! !

!ESEvent methodsFor: 'testing' stamp: 'AndreHora 4/18/2011 11:36'!
hasElement

	^ element notNil! !

!ESEvent methodsFor: 'initialization' stamp: 'AndreHora 4/13/2011 10:29'!
initialize 

	super initialize.
	self initializeEvent: nil on: nil! !

!ESEvent methodsFor: 'initialization' stamp: 'AndreHora 4/13/2011 10:28'!
initializeEvent: aMorphicEvent on: anElement

	event := aMorphicEvent.
	element := current := anElement.! !

ESEvent subclass: #ESMouseEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESMouseEvent subclass: #ESMouseDown
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESMouseEvent subclass: #ESMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

!ESMouseEvent methodsFor: 'testing-mouse' stamp: 'AndreHora 6/13/2011 18:09'!
isLeftButtonPressed

	event ifNil: [ ^ true ].
	^ event redButtonPressed! !

!ESMouseEvent methodsFor: 'testing-mouse' stamp: 'AndreHora 6/13/2011 18:09'!
isMiddleButtonPressed

	^ event yellowButtonPressed! !

!ESMouseEvent methodsFor: 'testing-mouse' stamp: 'AndreHora 6/13/2011 18:09'!
isRightButtonPressed

	^ event blueButtonPressed! !

!ESMouseEvent methodsFor: 'accessing' stamp: 'AndreHora 4/18/2011 11:42'!
position

	event ifNil: [ ^ 0@0].
	^ event position! !

ESMouseEvent subclass: #ESMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESMouseEvent subclass: #ESMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!

ESMouseEvent subclass: #ESMouseUp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Events'!
